import Combine

extension BusUI {
  public final class Value<T>: ObservableObject {
    @Published public var v: T
    var subscriptions = [AnyCancellable]()
   
    public init(
      _ key: String,
      _ defaultValue: T
    ) {
      v = defaultValue
      Bus.receive(
        [key],
        { [weak self] (_, v: T) in self?.v = v },
        sub: &subscriptions
      )
    }
  }
}
